#!/usr/bin/perl -w

# script names

$script[0] = "irefile";
$script[1] = "ifilter";


# gets parent working directory

open(PWD, "echo \$PWD | ") || die "Couldn't get PWD\n";

$_ = <PWD>;
chop;
$cur_dir = $_;

close(PWD);

if ($cur_dir =~ m/[^\/]$/) { $cur_dir .= "/"; }


# get the location of mh binaries

# $refile_default = "/usr/bin/mh/";
$rmm_default = "/usr/bin/rmm/";
$rcvstore_default = "/usr/lib/rcvstore/";
$perl_default = "/usr/bin/";

print "\n";

$refile_dir = &get_dir("refile", "bin");
print "$refile_dir\n";
$rmm_dir = &get_dir("rmm", "bin");
print "$rmm_dir\n";
$rcvstore_dir = &get_dir("rcvstore", "lib");
print "$rcvstore_dir\n";
$perl_dir = &get_dir("perl", "bin");
print "$perl_dir\n";

print "\n";

# gets the user's home directory to perform modification of .maildelivery file

$home_dir = "";

while (!opendir(DIR, $home_dir)) 
{
       print "Where is your home directory?  ";
       $home_dir = <STDIN>;
       chop $home_dir;

       if (($home_dir eq "") || ($home_dir =~ m/root/)) {
	   print "\nI need the directory of YOUR user account.\n\n";
	   $home_dir = "";
       }
}

if ($home_dir =~ m/[^\/]$/) { $home_dir .= "/"; }
print "Home dir = $home_dir\n\n";

# read in old .maildelivery file

if (open(MAIL, "< $home_dir.maildelivery")) 
{
    @mail = <MAIL>;
    close(MAIL);
}
else 
{
    # Change this to 'Should I create it for you?'
    warn "** Could not open $home_dir.maildelivery file (I'll create it for you)\n";
}

# creating new .maildelivery file

if (open(MAIL, "> $home_dir.maildelivery"))
{
    print MAIL "* - ^ ? $cur_dir$script[1]\n";
    foreach $line (@mail) { 
	print MAIL $line unless (($line =~ m/ifilter/) || ($line =~ m/default/));
    }
    print MAIL "default - ^ ? \"${rcvstore_dir}rcvstore +inbox\"\n";
    close(MAIL);
    $write_maildelivery = "true";

    chmod(0644, "$home_dir.maildelivery");
} 
else
{ 
    warn "** Could not create $home_dir.maildelivery file!\n"; 
    $write_maildelivery = "false";
}



# if perl resides in a location other than /usr/bin/, open up the two scripts,
#   and replace the #! line with the actual location

print "Modifying ifilter \& irefile to reflect new binary locations...\n";

foreach $file (@script)
{
    open(IN, "< $cur_dir$file") || die "Could not open $cur_dir$file for reading\n";
	
    @stuff = <IN>;
	
    open(OUT, "> $cur_dir$file") || 
	die "Could not open $cur_dir$file for writing\n";
	
    foreach $line (@stuff) {
	$line =~ s/#!\/usr\/bin\/perl/#!${perl_dir}perl/;
	$line =~ s/\/usr\/lib\/mh\/rcvstore/${rcvstore_dir}rcvstore/;
        $line =~ s/\/usr\/bin\/mh\/rmm/${rmm_dir}rmm/;
        print OUT $line;
    }
    close(IN);
    close(OUT);
}

chmod 0755, "$script[0]";
chmod 0755, "$script[1]";


# check to see whether 'refile' is an actual binary or just a link.  If it
#   is a link, we don't want to try to back it up.  If it is an actual binary,
#   move it to refile.bak

open(LS, "ls -l ${refile_dir}refile | ") || die "Couldn't ls -l ${refile_dir}refile\n";
$_ = <LS>;
close(LS);

print "Backing up mh refile binary...\n";

if (m/^l/) {
    warn "** ${refile_dir}refile is a link, I can't back it up!\n";
    # Change this to ask the question, 'Should I remove the link?'
    print "Removing ${refile_dir}refile...\n";
    system "rm", "${refile_dir}refile";
} else {
    system "mv", "${refile_dir}refile", "${refile_dir}refile.bak";
}

# link 'refile' to the location of irefile
print "Creating link from ${refile_dir}refile to irefile...\n";

symlink("$cur_dir$script[0]", "${refile_dir}refile");


# if the writing of .maildelivery didn't work, tell the user what to do.

if ($write_maildelivery eq "false") {
    print "\nPlease add the following line to the top of your .maildelivery";
    print "file:\n(it is necessary for anyone who wishes to use this";
    print "filtering system)\n\n";
    print "* - ^ ? $cur_dir$script[1]\n";
}

print "\nRemember to set your default incorporate method to presort.\n";

print "All done!\n";




sub get_dir {

    local($binary, $sub_dir) = @_;

    # searches the likely directories for the binary...

    if (open(FILE, "< /usr/$sub_dir/mh/$binary")) 
    {
	$binary_dir = "/usr/$sub_dir/mh/";
	print "Found $binary in /usr/$sub_dir/mh/\n";
    } 
    elsif (open(FILE, "< /usr/$sub_dir/$binary"))
    {
	$binary_dir = "/usr/$sub_dir/";
	print "Found $binary in /usr/$sub_dir/\n";
    }
    elsif (open(FILE, "< /usr/local/$sub_dir/$binary")) 
    {
	$binary_dir = "/usr/local/$sub_dir/";
	print "Found $binary in /usr/local/$sub_dir/\n";
    }
    elsif (open(FILE, "< /usr/local/$sub_dir/mh/$binary")) 
    {
	$binary_dir = "/usr/local/$sub_dir/mh/";
	print "Found $binary in /usr/local/$sub_dir/mh/\n";
    }
    else
    {
	print "$binary not found in /usr/$sub_dir/mh/ /usr/local/$sub_dir/\n";
	print "    /usr/local/$sub_dir/mh/ /usr/$sub_dir/\n";
	do 
	{
	    print "What directory is your $binary binary in?  ";
	
	    $binary_dir = <STDIN>;
	    chop $binary_dir;
	    
	} while (!opendir(DIR, $binary_dir));

	if ($binary_dir =~ m/[^\/]$/) { $binary_dir .= "/"; }
	print "$binary dir = $binary_dir\n";
    }

    $binary_dir;
}
